ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.26
Committed: Tue Oct 25 20:51:10 2011 UTC (12 years, 6 months ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.25: +15 -9 lines
Log Message:
Fixed bug for tensor tree with -n > 1 & +forw +back

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.25 2011/08/24 04:14:58 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 use File::Temp qw/ :mktemp /;
10 sub userror {
11 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 exit 1;
13 }
14 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 chomp $td;
16 my @savedARGV = @ARGV;
17 my $tensortree = 0;
18 my $ttlog2 = 4;
19 my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21 my $mgfin = 0;
22 my $geout = 1;
23 my $nproc = 1;
24 my $doforw = 0;
25 my $doback = 1;
26 my $gunit = "Meter";
27 my @dim;
28 # Get options
29 while ($#ARGV >= 0) {
30 if ("$ARGV[0]" =~ /^[-+]m/) {
31 $mgfin = ("$ARGV[0]" =~ /^\+/);
32 } elsif ("$ARGV[0]" eq "-r") {
33 $rtargs = "$rtargs $ARGV[1]";
34 shift @ARGV;
35 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
36 $geout = ("$ARGV[0]" =~ /^\+/);
37 $gunit = $ARGV[1];
38 if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
39 die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
40 }
41 shift @ARGV;
42 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
43 $doforw = ("$ARGV[0]" =~ /^\+/);
44 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
45 $doback = ("$ARGV[0]" =~ /^\+/);
46 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
47 $tensortree = substr($ARGV[0], 2, 1);
48 $ttlog2 = $ARGV[1];
49 shift @ARGV;
50 } elsif ("$ARGV[0]" eq "-c") {
51 $nsamp = $ARGV[1];
52 shift @ARGV;
53 } elsif ("$ARGV[0]" eq "-n") {
54 $nproc = $ARGV[1];
55 shift @ARGV;
56 } elsif ("$ARGV[0]" =~ /^-d/) {
57 userror() if ($#ARGV < 6);
58 @dim = @ARGV[1..6];
59 shift @ARGV for (1..6);
60 } elsif ("$ARGV[0]" =~ /^[-+]./) {
61 userror();
62 } else {
63 last;
64 }
65 shift @ARGV;
66 }
67 # Check that we're actually being asked to do something
68 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
69 # Name our own persist file?
70 my $persistfile;
71 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
72 $persistfile = "$td/pfile.txt";
73 $rtargs = "-PP $persistfile $rtargs";
74 }
75 # Get scene description and dimensions
76 my $radscn = "$td/device.rad";
77 my $mgfscn = "$td/device.mgf";
78 my $octree = "$td/device.oct";
79 if ( $mgfin ) {
80 system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
81 die "Could not load MGF input\n" if ( $? );
82 system "mgf2rad $mgfscn > $radscn";
83 } else {
84 system "xform -e @ARGV > $radscn";
85 die "Could not load Radiance input\n" if ( $? );
86 system "rad2mgf $radscn > $mgfscn" if ( $geout );
87 }
88 if ($#dim != 5) {
89 @dim = split ' ', `getbbox -h $radscn`;
90 }
91 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
92 # Add receiver surfaces (rectangular)
93 my $fmodnm="receiver_face";
94 my $bmodnm="receiver_behind";
95 open(RADSCN, ">> $radscn");
96 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
97 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
98 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
99 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
100 close RADSCN;
101 # Generate octree
102 system "oconv -w $radscn > $octree";
103 die "Could not compile scene\n" if ( $? );
104 # Output XML prologue
105 print
106 '<?xml version="1.0" encoding="UTF-8"?>
107 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
108 ';
109 print "<!-- File produced by: genBSDF @savedARGV -->\n";
110 print
111 '<WindowElementType>System</WindowElementType>
112 <Optical>
113 <Layer>
114 <Material>
115 <Name>Name</Name>
116 <Manufacturer>Manufacturer</Manufacturer>
117 ';
118 printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 print "\t\t<DeviceType>Integral</DeviceType>\n";
122 # Output MGF description if requested
123 if ( $geout ) {
124 print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
125 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
126 open(MGFSCN, "< $mgfscn");
127 while (<MGFSCN>) { print $_; }
128 close MGFSCN;
129 print "xf\n";
130 print "\t\t</Geometry>\n";
131 }
132 print " </Material>\n";
133 # Set up surface sampling
134 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
135 my $ny = int($nsamp/$nx + .5);
136 $nsamp = $nx * $ny;
137 my $ns = 2**$ttlog2;
138 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
139 # Create data segments (all the work happens here)
140 if ( $tensortree ) {
141 do_tree_bsdf();
142 } else {
143 do_matrix_bsdf();
144 }
145 # Output XML epilogue
146 print
147 '</Layer>
148 </Optical>
149 </WindowElement>
150 ';
151 # Clean up temporary files and exit
152 exec("rm -rf $td");
153
154 #-------------- End of main program segment --------------#
155
156 #++++++++++++++ Kill persistent rtrace +++++++++++++++++++#
157 sub persist_end {
158 if ( $persistfile && open(PFI, "< $persistfile") ) {
159 while (<PFI>) {
160 s/^[^ ]* //;
161 kill('ALRM', $_);
162 last;
163 }
164 close PFI;
165 }
166 }
167
168 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
169 sub do_tree_bsdf {
170 # Get sampling rate and subdivide task
171 my $ns2 = $ns;
172 $ns2 /= 2 if ( $tensortree == 3 );
173 my $nsplice = $nproc;
174 $nsplice *= 10 if ($nproc > 1);
175 $nsplice = $ns2 if ($nsplice > $ns2);
176 $nsplice = 999 if ($nsplice > 999);
177 @pdiv = (0, int($ns2/$nsplice));
178 my $nrem = $ns2 % $nsplice;
179 for (my $i = 1; $i < $nsplice; $i++) {
180 my $nv = $pdiv[$i] + $pdiv[1];
181 ++$nv if ( $nrem-- > 0 );
182 push @pdiv, $nv;
183 }
184 die "Script error 1" if ($pdiv[-1] != $ns2);
185 # Shirley-Chiu mapping from unit square to disk
186 $sq2disk = '
187 in_square_a = 2*in_square_x - 1;
188 in_square_b = 2*in_square_y - 1;
189 in_square_rgn = if(in_square_a + in_square_b,
190 if(in_square_a - in_square_b, 1, 2),
191 if(in_square_b - in_square_a, 3, 4));
192 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
193 -in_square_a, -in_square_b);
194 out_disk_phi = PI/4 * select(in_square_rgn,
195 in_square_b/in_square_a,
196 2 - in_square_a/in_square_b,
197 4 + in_square_b/in_square_a,
198 if(in_square_b*in_square_b,
199 6 - in_square_a/in_square_b, 0));
200 Dx = out_disk_r*cos(out_disk_phi);
201 Dy = out_disk_r*sin(out_disk_phi);
202 Dz = sqrt(1 - out_disk_r*out_disk_r);
203 ';
204 # Shirley-Chiu mapping from unit disk to square
205 $disk2sq = '
206 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
207 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
208 in_disk_phi = norm_radians(atan2(Dy, Dx));
209 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
210 out_square_a = select(in_disk_rgn,
211 in_disk_r,
212 (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
213 -in_disk_r,
214 (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
215 out_square_b = select(in_disk_rgn,
216 in_disk_phi*in_disk_r/(PI/4),
217 in_disk_r,
218 (PI - in_disk_phi)*in_disk_r/(PI/4),
219 -in_disk_r);
220 out_square_x = (out_square_a + 1)/2;
221 out_square_y = (out_square_b + 1)/2;
222 ';
223 # Announce ourselves in XML output
224 print "\t<DataDefinition>\n";
225 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
226 print "\t</DataDefinition>\n";
227 # Fork parallel rtcontrib processes to compute each side
228 my $npleft = $nproc;
229 if ( $doback ) {
230 for (my $splice = 0; $splice < $nsplice; $splice++) {
231 if (! $npleft ) {
232 wait();
233 die "rtcontrib process reported error" if ( $? );
234 $npleft++;
235 }
236 bg_tree_rtcontrib(0, $splice);
237 $npleft--;
238 }
239 while (wait() >= 0) {
240 die "rtcontrib process reported error" if ( $? );
241 $npleft++;
242 }
243 persist_end();
244 ttree_out(0);
245 }
246 if ( $doforw ) {
247 for (my $splice = 0; $splice < $nsplice; $splice++) {
248 if (! $npleft ) {
249 wait();
250 die "rtcontrib process reported error" if ( $? );
251 $npleft++;
252 }
253 bg_tree_rtcontrib(1, $splice);
254 $npleft--;
255 }
256 while (wait() >= 0) {
257 die "rtcontrib process reported error" if ( $? );
258 $npleft++;
259 }
260 persist_end();
261 ttree_out(1);
262 }
263 } # end of sub do_tree_bsdf()
264
265 # Run rtcontrib process in background to generate tensor tree samples
266 sub bg_tree_rtcontrib {
267 my $pid = fork();
268 die "Cannot fork new process" unless defined $pid;
269 if ($pid > 0) { return $pid; }
270 my $forw = shift;
271 my $pn = shift;
272 my $pbeg = $pdiv[$pn];
273 my $plen = $pdiv[$pn+1] - $pbeg;
274 my $matargs = "-m $bmodnm";
275 if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
276 my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
277 "-e '$disk2sq' -bn '$ns*$ns' " .
278 "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
279 "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
280 if ( $tensortree == 3 ) {
281 # Isotropic BSDF
282 $cmd = "cnt $plen $ny $nx " .
283 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
284 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
285 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
286 "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
287 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
288 "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
289 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
290 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
291 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
292 "| $cmd";
293 } else {
294 # Anisotropic BSDF
295 # Sample area vertically to improve load balance, since
296 # shading systems usually have bilateral symmetry (L-R)
297 $cmd = "cnt $plen $ns $ny $nx " .
298 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
299 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
300 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
301 "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
302 "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
303 "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
304 "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
305 "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
306 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
307 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
308 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
309 "| $cmd";
310 }
311 # print STDERR "Starting: $cmd\n";
312 exec($cmd); # no return; status report to parent via wait
313 die "Cannot exec: $cmd\n";
314 } # end of bg_tree_rtcontrib()
315
316 # Simplify and output tensor tree results
317 sub ttree_out {
318 my $forw = shift;
319 my $side = ("Back","Front")[$forw];
320 # Only output one transmitted distribution, preferring backwards
321 if ( !$forw || !$doback ) {
322 print
323 ' <WavelengthData>
324 <LayerNumber>System</LayerNumber>
325 <Wavelength unit="Integral">Visible</Wavelength>
326 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
327 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
328 <WavelengthDataBlock>
329 <WavelengthDataDirection>Transmission</WavelengthDataDirection>
330 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
331 <ScatteringDataType>BTDF</ScatteringDataType>
332 <ScatteringData>
333 ';
334 system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
335 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
336 "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
337 "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
338 die "Failure running rttree_reduce" if ( $? );
339 print
340 ' </ScatteringData>
341 </WavelengthDataBlock>
342 </WavelengthData>
343 ';
344 }
345 # Output reflection
346 print
347 ' <WavelengthData>
348 <LayerNumber>System</LayerNumber>
349 <Wavelength unit="Integral">Visible</Wavelength>
350 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
351 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
352 <WavelengthDataBlock>
353 ';
354 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
355 print
356 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
357 <ScatteringDataType>BRDF</ScatteringDataType>
358 <ScatteringData>
359 ';
360 system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
361 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
362 "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
363 "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
364 die "Failure running rttree_reduce" if ( $? );
365 print
366 ' </ScatteringData>
367 </WavelengthDataBlock>
368 </WavelengthData>
369 ';
370 } # end of ttree_out()
371
372 #------------- End of do_tree_bsdf() & subroutines -------------#
373
374 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
375 sub do_matrix_bsdf {
376 # Set up sampling of portal
377 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
378 $tcal = '
379 DEGREE : PI/180;
380 sq(x) : x*x;
381 Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
382 Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
383 Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
384 Kmax : Kaccum(Knaz(0));
385 Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
386 Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
387 Kcol = Kbin - Kaccum(Krow-1);
388 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
389 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
390 sin_kpol = sin(Kpol);
391 Dx = cos(Kazi)*sin_kpol;
392 Dy = sin(Kazi)*sin_kpol;
393 Dz = sqrt(1 - sin_kpol*sin_kpol);
394 KprojOmega = PI * if(Kbin-.5,
395 (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
396 1 - sq(cos(Kpola(1)*DEGREE)));
397 ';
398 # Compute Klems bin from exiting ray direction (forward or backward)
399 $kcal = '
400 DEGREE : PI/180;
401 abs(x) : if(x, x, -x);
402 Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
403 posangle(a) : if(-a, a + 2*PI, a);
404 Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
405 kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
406 knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
407 kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
408 kfindrow(r, pol) : if(r-kpola(0)+.5, r,
409 if(pol-kpola(r), kfindrow(r+1, pol), r) );
410 kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
411 kbin2(pol,azi) = select(kfindrow(1, pol),
412 kazn(azi,360/knaz(1)),
413 kaccum(1) + kazn(azi,360/knaz(2)),
414 kaccum(2) + kazn(azi,360/knaz(3)),
415 kaccum(3) + kazn(azi,360/knaz(4)),
416 kaccum(4) + kazn(azi,360/knaz(5)),
417 kaccum(5) + kazn(azi,360/knaz(6)),
418 kaccum(6) + kazn(azi,360/knaz(7)),
419 kaccum(7) + kazn(azi,360/knaz(8)),
420 kaccum(8) + kazn(azi,360/knaz(9))
421 );
422 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
423 ';
424 my $ndiv = 145;
425 # Compute scattering data using rtcontrib
426 my @tfarr;
427 my @rfarr;
428 my @tbarr;
429 my @rbarr;
430 my $cmd;
431 my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
432 "-e '$kcal' -b kbin -bn $ndiv " .
433 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
434 my $rccmd = "rcalc -e '$tcal' " .
435 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
436 q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
437 q[-o '${ oval },'];
438 if ( $doforw ) {
439 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
440 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
441 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
442 "-e 'zp:$dim[4]' " .
443 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
444 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
445 "| $rtcmd";
446 system "$cmd" || die "Failure running: $cmd\n";
447 @tfarr = `$rccmd $td/$fmodnm.flt`;
448 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
449 @rfarr = `$rccmd $td/$bmodnm.flt`;
450 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
451 }
452 if ( $doback ) {
453 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
454 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
455 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
456 "-e 'zp:$dim[5]' " .
457 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
458 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
459 "| $rtcmd";
460 system "$cmd" || die "Failure running: $cmd\n";
461 @tbarr = `$rccmd $td/$bmodnm.flt`;
462 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
463 @rbarr = `$rccmd $td/$fmodnm.flt`;
464 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
465 }
466 # Output angle basis
467 print
468 ' <DataDefinition>
469 <IncidentDataStructure>Columns</IncidentDataStructure>
470 <AngleBasis>
471 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
472 <AngleBasisBlock>
473 <Theta>0</Theta>
474 <nPhis>1</nPhis>
475 <ThetaBounds>
476 <LowerTheta>0</LowerTheta>
477 <UpperTheta>5</UpperTheta>
478 </ThetaBounds>
479 </AngleBasisBlock>
480 <AngleBasisBlock>
481 <Theta>10</Theta>
482 <nPhis>8</nPhis>
483 <ThetaBounds>
484 <LowerTheta>5</LowerTheta>
485 <UpperTheta>15</UpperTheta>
486 </ThetaBounds>
487 </AngleBasisBlock>
488 <AngleBasisBlock>
489 <Theta>20</Theta>
490 <nPhis>16</nPhis>
491 <ThetaBounds>
492 <LowerTheta>15</LowerTheta>
493 <UpperTheta>25</UpperTheta>
494 </ThetaBounds>
495 </AngleBasisBlock>
496 <AngleBasisBlock>
497 <Theta>30</Theta>
498 <nPhis>20</nPhis>
499 <ThetaBounds>
500 <LowerTheta>25</LowerTheta>
501 <UpperTheta>35</UpperTheta>
502 </ThetaBounds>
503 </AngleBasisBlock>
504 <AngleBasisBlock>
505 <Theta>40</Theta>
506 <nPhis>24</nPhis>
507 <ThetaBounds>
508 <LowerTheta>35</LowerTheta>
509 <UpperTheta>45</UpperTheta>
510 </ThetaBounds>
511 </AngleBasisBlock>
512 <AngleBasisBlock>
513 <Theta>50</Theta>
514 <nPhis>24</nPhis>
515 <ThetaBounds>
516 <LowerTheta>45</LowerTheta>
517 <UpperTheta>55</UpperTheta>
518 </ThetaBounds>
519 </AngleBasisBlock>
520 <AngleBasisBlock>
521 <Theta>60</Theta>
522 <nPhis>24</nPhis>
523 <ThetaBounds>
524 <LowerTheta>55</LowerTheta>
525 <UpperTheta>65</UpperTheta>
526 </ThetaBounds>
527 </AngleBasisBlock>
528 <AngleBasisBlock>
529 <Theta>70</Theta>
530 <nPhis>16</nPhis>
531 <ThetaBounds>
532 <LowerTheta>65</LowerTheta>
533 <UpperTheta>75</UpperTheta>
534 </ThetaBounds>
535 </AngleBasisBlock>
536 <AngleBasisBlock>
537 <Theta>82.5</Theta>
538 <nPhis>12</nPhis>
539 <ThetaBounds>
540 <LowerTheta>75</LowerTheta>
541 <UpperTheta>90</UpperTheta>
542 </ThetaBounds>
543 </AngleBasisBlock>
544 </AngleBasis>
545 </DataDefinition>
546 ';
547 if ( $doforw ) {
548 print
549 ' <WavelengthData>
550 <LayerNumber>System</LayerNumber>
551 <Wavelength unit="Integral">Visible</Wavelength>
552 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
553 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
554 <WavelengthDataBlock>
555 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
556 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
557 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
558 <ScatteringDataType>BTDF</ScatteringDataType>
559 <ScatteringData>
560 ';
561 # Output front transmission (transposed order)
562 for (my $od = 0; $od < $ndiv; $od++) {
563 for (my $id = 0; $id < $ndiv; $id++) {
564 print $tfarr[$ndiv*$id + $od];
565 }
566 print "\n";
567 }
568 print
569 ' </ScatteringData>
570 </WavelengthDataBlock>
571 </WavelengthData>
572 <WavelengthData>
573 <LayerNumber>System</LayerNumber>
574 <Wavelength unit="Integral">Visible</Wavelength>
575 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
576 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
577 <WavelengthDataBlock>
578 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
579 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
580 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
581 <ScatteringDataType>BRDF</ScatteringDataType>
582 <ScatteringData>
583 ';
584 # Output front reflection (transposed order)
585 for (my $od = 0; $od < $ndiv; $od++) {
586 for (my $id = 0; $id < $ndiv; $id++) {
587 print $rfarr[$ndiv*$id + $od];
588 }
589 print "\n";
590 }
591 print
592 ' </ScatteringData>
593 </WavelengthDataBlock>
594 </WavelengthData>
595 ';
596 }
597 if ( $doback ) {
598 print
599 ' <WavelengthData>
600 <LayerNumber>System</LayerNumber>
601 <Wavelength unit="Integral">Visible</Wavelength>
602 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
603 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
604 <WavelengthDataBlock>
605 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
606 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
607 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
608 <ScatteringDataType>BTDF</ScatteringDataType>
609 <ScatteringData>
610 ';
611 # Output back transmission (transposed order)
612 for (my $od = 0; $od < $ndiv; $od++) {
613 for (my $id = 0; $id < $ndiv; $id++) {
614 print $tbarr[$ndiv*$id + $od];
615 }
616 print "\n";
617 }
618 print
619 ' </ScatteringData>
620 </WavelengthDataBlock>
621 </WavelengthData>
622 <WavelengthData>
623 <LayerNumber>System</LayerNumber>
624 <Wavelength unit="Integral">Visible</Wavelength>
625 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
626 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
627 <WavelengthDataBlock>
628 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
629 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
630 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
631 <ScatteringDataType>BRDF</ScatteringDataType>
632 <ScatteringData>
633 ';
634 # Output back reflection (transposed order)
635 for (my $od = 0; $od < $ndiv; $od++) {
636 for (my $id = 0; $id < $ndiv; $id++) {
637 print $rbarr[$ndiv*$id + $od];
638 }
639 print "\n";
640 }
641 print
642 ' </ScatteringData>
643 </WavelengthDataBlock>
644 </WavelengthData>
645 ';
646 }
647 }
648 #------------- End of do_matrix_bsdf() --------------#